标签:style blog color os 数据 width
Simon and Antisimon play a game. Initially each player receives one fixed positive integer that doesn‘t change throughout the game. Simon receives number a and Antisimon receives number b. They also have a heap of nstones. The players take turns to make a move and Simon starts. During a move a player should take from the heap the number of stones equal to the greatest common divisor of the fixed number he has received and the number of stones left in the heap. A player loses when he cannot take the required number of stones (i. e. the heap has strictly less stones left than one needs to take).
Your task is to determine by the given a, b and n who wins the game.
The only string contains space-separated integers a, b and n (1?≤?a,?b,?n?≤?100) — the fixed numbers Simon and Antisimon have received correspondingly and the initial number of stones in the pile.
If Simon wins, print "0" (without the quotes), otherwise print "1" (without the quotes).
3 5 9
0
1 1 100
1
这样的题目一般都可以找公式的,但是本题却是找不到什么好的公式了。
只有暴力去模拟玩这个游戏了。还好因为其数据不大,故此也许出题者也是没有公式的。
namespace{ int GCD(int a, int b) { if (1 == a || b == 1) return 1; while (b) { int t = b; b = a%b; a = t; } return a; } } void EpicGame() { int a, b, c, d; cin>>a>>b>>c; bool goGame = 0; while (c >= 0) { if (goGame) d = GCD(b, c); else d = GCD(a, c); c -= d; goGame = !goGame; } cout<<goGame; }
codeforces Epic Game 题解,码迷,mamicode.com
标签:style blog color os 数据 width
原文地址:http://blog.csdn.net/kenden23/article/details/24762737